Redmine - Feature #3143

Add an 'Add Note' function to issue, to avoid optimistic-lock of issue' update when user just want to
add a note

2009-04-08 14:09 - Chaoqun Zou

Status: New Start date: 2009-04-08
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution:

Description

Most of the issue's update operations are to add a note but not to update the issue's attributes. And if an issue is updated frequently,
there may be lots of optimistic-locks which prevent the issue to be saved.

So | thought it would be better to extract the 'add note' function from issue's update, then multi-users can add their notes
simultaneously.

Related issues:

Related to Redmine - Feature #12060: Add comment field under the ticket New

Related to Redmine - Feature #12917: easy adding new notes/comments to issue New

Related to Redmine - Feature #17740: New context menu entry: "Add comment" New

Related to Redmine - Feature #4091: "Comment" link for issues New 2009-10-23
Related to Redmine - Feature #3852: Allow users to comment on issues without ... New 2009-09-12
History

#1 - 2013-03-22 16:19 - Dipan Mehta
Duplicated by #12060 #12917

#2 - 2014-04-22 18:33 - Ismael Barros?
+1, I'd very much welcome this feature :)
Almost none of the people I've worked with (programmers, technical people) was able to understand at first glance how to add a comment in a issue

#3 - 2014-07-10 23:56 - Dmitry Bezrukov

Redmine is a great software, only it took me some time to understand on how to add a note/comment.
| would expect it to be at the bottom of the issue notes.

Great GUI rule: Don't let me read a manual.

Thanks for prioritizing this improvement.

#4 - 2014-10-08 09:53 - Ismael Barros?

Does anyone know if there's any plugin out there that implements this functionality?

#5 - 2014-11-12 22:37 - Nic Laflin

| too would like to see this, it seems that the quote button almost handle's this.

#6 - 2014-11-30 16:02 - Go MAEDA

- Related to Feature #17740: New context menu entry: "Add comment" added

#7 - 2014-11-30 16:05 - Go MAEDA

- Related to Feature #4091: "Comment" link for issues added

#8 - 2014-11-30 16:05 - Go MAEDA

- Related to Feature #3852: Allow users to comment on issues without having to go through Update added

#9 - 2015-02-16 20:47 - WDS D
| am desperately looking for that feature. And also the ability to display notes/comments and change history separately
Ismael Barros? wrote:

Does anyone know if there's any plugin out there that implements this functionality?

#10 - 2015-02-22 13:52 - dumb blob

I'd like to raise my hand for this as well. It's utterly important for our organization as it's by far the most frequent confusion among users.

Also, the tiny, nearly invisible, pencil button near "Description:" should be expanded by default when updating/editing the issue.

#11 - 2016-01-13 14:29 - Michael Erne
Hi everybody,

We recently switched on Redmine and would love to have a function to add quickly a note because editing an issue to quickly add a note seems
really disturbing to us. It is really usefull to take notes related to each issue so that we have all the informations and questions we had about it. What
is planned for this point? Will the next release have something like this?

Thank you very much for your answer.

Best Regards, Michael

#12 - 2016-04-16 19:20 - Marius BALTEANU
- File add_notes.png added

- File add_notes_form.png added

- File add_notes_button.patch added

I've attached a patch (add_notes_button.patch) that implements this feature by adding a new button named "Add notes" to the bottom of the issue
page.

add_notes.png
After is clicked, the form for adding notes and attachments is shown.

add_notes_form.png
If the patch is accepted, I'll update it to include:
-a Ul test
- Translations for current languages.

Also, the current tests pass

#13 - 2016-04-19 10:54 - Oscar Edvardsson

Nice to see some work being done on this issue!

| tried your patch though, and for me it only seems to reload the page. | can see in the log though that it does render it (Rendered
journals/_notes_new_form.html.erb (11.4ms)).

| have verified that the patch was applied successfully, and | have tried with both the custom theme we are using and default theme and with different

users (one of them admin) - with no luck. | have not made any other modifications to Redmine, save for a mylyn connector.

Environment:

Redmine version 3.2.0.stable

Ruby version 1.9.3-p484 (2013-11-22) [x86_64-linux]
Rails version 425

Environment production

Database adapter PostgreSQL

SCM:

Mercurial 2.8.2

Git 1.9.1

Filesystem

Redmine plugins:
redmine_mylyn_connector 2.8.2.stable

#14 - 2016-04-19 11:19 - Marius BALTEANU
Oscar Edvardsson wrote:

Nice to see some work being done on this issue!

| tried your patch though, and for me it only seems to reload the page. | can see in the log though that it does render it (Rendered
journals/_notes_new_form.html.erb (11.4ms)).
| have verified that the patch was applied successfully, and | have tried with both the custom theme we are using and default theme and with
different users (one of them admin) - with no luck. | have not made any other modifications to Redmine, save for a mylyn connector.

Environment:

Redmine version 3.2.0.stable

Ruby version 1.9.3-p484 (2013-11-22) [x86_64-linux]
Rails version 425

Environment production

Database adapter PostgreSQL

SCM:

Mercurial 2.8.2

Git 1.9.1

Filesystem

Redmine plugins:
redmine_mylyn_connector 2.8.2.stable

The patch was developed against Revision r15317

| tested now on 3.2.1-stable and works fine. I'll try later to test the patch against version 3.2.0.stable and also against latest revision.

My Environment:

Redmine version 3.2.1.devel

Ruby version 2.2.3-p173 (2015-08-18) [x86_64-linux]
Rails version 4252

Environment development

Database adapter Mysql2

#15 - 2016-04-20 11:14 - Marius BALTEANU
Marius BALTEANU wrote:

I'll try later to test the patch against version 3.2.0.stable and also against latest revision.
| tested also on 3.2.0 (with and without your plugin) and works fine (Chrome and Firefox latest versions). That reload should be a POST request to

/issues/<id> and you should receive a 302 redirect as response from the server (the patch uses the same post method from edit issues). | don't know
how can | help you further to debug your problem, so I'll wait for someone else feedback.

#16 - 2016-04-20 11:31 - Oscar Edvardsson
Marius BALTEANU wrote:
| tested also on 3.2.0 (with and without your plugin) and works fine (Chrome and Firefox latest versions). That reload should be a POST request

to /issues/<id> and you should receive a 302 redirect as response from the server (the patch uses the same post method from edit issues). |
don't know how can | help you further to debug your problem, so I'll wait for someone else feedback.

I never thought of testing a different browser... Works on Chrome, but not Safari (Version 9.1 (11601.5.17.1)).

#17 - 2016-04-20 11:34 - Marius BALTEANU

Thanks for the feedback, I'll check why the patch is not working on Safari.

#18 - 2016-04-21 21:12 - Marius BALTEANU
I've just tested the patch on Safari Version 9.1 (11601.5.17.1) and works fine.

#19 - 2016-04-22 10:07 - Oscar Edvardsson

Odd, now it works splendidly. | did restart Redmine though, maybe that was needed...?

#20 - 2016-04-22 10:11 - Marius BALTEANU

Oscar Edvardsson wrote:

Odd, now it works splendidly. | did restart Redmine though, maybe that was needed...?

Yes, restarting the application server is a must.

#21 - 2016-04-28 03:22 - the fury

Would it be possible to have that "add note" field open by default, like the reply box in most forums (XenForo, etc.)?
For that matter, the same should happen on threads in Redmine forum...
That would make it super easy to comment on an issue
#22 - 2016-04-28 13:50 - Marius BALTEANU
the fury wrote:
Would it be possible to have that "add note" field open by default, like the reply box in most forums (XenForo, etc.)?
For that matter, the same should happen on threads in Redmine forum...
That would make it super easy to comment on an issue
Both solutions requires one click for adding a note:
- "Add Notes" button: After you click it, the focus is set automatically on the field and you can start typing
- Field box open by default: you need to click on it to focus the field
Because of that, | would prefer the "Add notes" button.
#23 - 2016-04-28 15:24 - the fury
Marius BALTEANU wrote:
the fury wrote:
Would it be possible to have that "add note" field open by default, like the reply box in most forums (XenForo, etc.)?
For that matter, the same should happen on threads in Redmine forum...
That would make it super easy to comment on an issue
Both solutions requires one click for adding a note:
- "Add Notes" button: After you click it, the focus is set automatically on the field and you can start typing
- Field box open by default: you need to click on it to focus the field
Because of that, | would prefer the "Add notes" button.
True, only a single action in both cases, but in terms of intuitive interface, if the comment field is visible by default, it makes it obvious that's where one
goes to leave a comment on the issue, so people don't have to hunt around or get trained on how to use the thing. I'm faced with the task of bringing
dozens of people at work on board to Redmine, where the existing "system" is email and Office docs on network shares...so really, anything's an
improvement, but I'm hoping to minimize the friction against change by having the most discoverable Ul possible.
Now that | look at the patch, it's just a matter of the CSS, so | could just override it in my theme. I'm cool with that, going to apply the patch now. :)
#24 - 2016-04-28 20:28 - the fury
Marius BALTEANU wrote:
I've attached a patch (add_notes_button.patch) that implements this feature by adding a new button named "Add notes" to the bottom of the
issue page.
I've applied the patch on my copy (I'm on 3.2.1-stable) and restarted Redmine, however the issue view now reports a 500 internal server error. | have
the redmine_ckeditor plugin installed, and it looks like there is something going wonky here:

ActionView::Template::Error (undefined method “id' for nil:NilClass):

il g <%= f.check_box :private_notes, :no_label => true %>

12: <label for="issue_private_notes"><%= (:field_private_notes) %> </label>

13: <% end %>

14: <%= call_hook (:view_journals_notes_form_after_notes, { :issue => @issue}) %>

15:

16: <p><%= render :partial => 'attachments/form', :locals => {:container => @issue} $%$></p>
17: </fieldset>

plugins/redmine_ckeditor/lib/redmine_ckeditor/hooks/journal_listener.rb:10:in “view_journals_notes_form_afte
r_notes'

lib/redmine/hook.rb:61:in “block (2 levels) in call_hook'

lib/redmine/hook.rb:61l:in “each'

lib/redmine/hook.rb:61:in ‘block in call_hook'

lib/redmine/hook.rb:58:in "tap'

lib/redmine/hook.rb:58:in “call_hook'

lib/redmine/hook.rb:96:in “call_hook'
app/views/journals/_notes_new_form.html.erb:14:in “block in _app_views_journals__notes_new_form_html_erb_ 41
04637093308884883_47486000"

app/helpers/application_helper.rb:1030:in "“labelled_form_for'

app/views/journals/_notes_new_form.html.erb:5:1in " _app_views_journals__notes_new_form_html_erb_ 410463709330
8884883_47486000"

app/views/issues/show.html.erb:132:in " _app_views_issues_show_html_erb__ 4381887501222243197_48895720"

app/controllers/issues_controller.rb:118:in “block (2 levels) in show'

app/controllers/issues_controller.rb:115:in " show'

lib/redmine/sudo_mode.rb:63:in "~ sudo_mode'

Line 10 in the file plugins/redmine_ckeditor/lib/redmine_ckeditor/hooks/journal_listener.rb:
var note_id = "journal_#{Jjournal.id}_notes";

| don't know a whole lot about Redmine code and plugins, but shouldn't it be passed a journal object in order for it to work, or should the listener on
the plugin be changed so that it works if it doesn't receive a journal object?

#25 - 2016-10-02 15:36 - Marius BALTEANU
- File add_notes_button_v3.patch added

Attached is an updated patch which includes some fixes.

| would really appreciate any feedback on this patch in order to have it committed in a further version.

#26 - 2016-10-09 22:38 - C-O L
- File add_notes.diff added
- File AddNotes.png added

Marius BALTEANU wrote:
Attached is an updated patch which includes some fixes.

| would really appreciate any feedback on this patch in order to have it committed in a further version.

Hi all,
| have always thought that the "Edit issue to leave a comment" was kind of odd, so now after Marius almost made it the way | wanted it | decided to
give it a try, so here is my contribution using 3.3.0 as base with great help from Marius patch:

e The Add notes form is always visible at the bottom of the page (after the History) for user allowed to add notes.

An "Add notes" link has been added to the action menu which takes the user to the Add notes form (for users allowed to add notes).

The "Edit" link in the action menu is only visible for users allowed to edit the issue.

The second action menu has been relocated from the bottom to just below the issue, before the history.

The edit issue form has been moved to below the second action menu. The edit issue form still has its own notes input.

The Add notes form is used when quoting.

Uploading files is working from both Edit issue and Add notes (with some color errors in the Ul for Add notes, maybe | missed something?)

#27 - 2016-10-11 14:04 - C-O L
- File add _notes v3.diff added

| reconsidered the implementation a bit an here is a new version that is using all the existing elements with some small adjustments so there are
fewer modifications and more likely to work with plugins.

e The Add notes form is always visible at the bottom of the page (after the History) for user allowed to add notes.

¢ An "Add notes" link has been added to the action menu which takes the user to the Add notes form (for users allowed to add notes).
e The "Edit" link in the action menu is only visible for users allowed to edit the issue.

e The second action menu has been relocated from the bottom to just below the issue details, | think it makes more sense there.

¢ The editissueform-has been-moved-to-below the second-action-men u he-editissue-form-still-has-its-own-notes-inpu

L]

#28 - 2017-02-22 15:16 - Sander Deryckere

- File missing_translation.JPG added

| just tried the patch by C-O L, and the interface does feel a lot better. Leaving an "Edit" button for admins, and just having an "Add note" button for
regular reporters.

The only problem I have is that the button doesn't find its text in the translation file. Though | guess that's due to me not compiling the translation files,
or not deleting the cache or so... | still need to figure out what's happening there.

missing_translation.JPG
Another remark is that the notes are placed in a div, so it looks like a box in a box in a box. That's not an issue with this patch, but with the existing
style. It makes sense for an admin to put all different edit panes in one div together, but for a regular reporter who can only add notes, there's a box
too much IMO.
All'in all, it's a great improvement for the user experience, and | hope this will be included in the next version.
#29 - 2017-03-28 13:10 - Shay Sol

Hi, | applied the patch, tried it and it has a problem with redmine_ckeditor. Someone solved it?

#30 - 2017-09-18 18:34 - Den Mayer

It can't work properly. When | installed the last patch the Edit button stopped opening the block for editing
Redmine version 3.3.1
Any of thoughts? In console (Devtools) | did not see any errors..

#31 - 2018-04-17 15:49 - Dan Weaver

Can anyone help to get it working on redmine 3.4? Really need this.

#32 - 2019-02-21 15:57 - Bernhard Rohloff

+1 If we could get this patch integrated it would be an extremely huge step forward.
This is the one of the first questions everybody asks if | show them how to use Redmine.

#33 - 2019-03-25 22:47 - Marius BALTEANU
- File 0001-Adds-Add-notes-link-to-issue-page-to-add-only-notes.patch added
- File add_notes.png added
- Target version set to Candidate for next major release
Bernhard Rohloff wrote:
+1 If we could get this patch integrated it would be an extremely huge step forward.
This is the one of the first questions everybody asks if | show them how to use Redmine.
| totally agree with you, Bernhard.

I'm attaching a patch created based on the patch proposed by C-O L. The patch implements partially this feature (partially because it doesn't avoid
the optimistic-lock) and it doesn't change the HTML of the page, it is based mostly on JS.

Eadd ihtiesipng00% happy with this solution, | think it is a good step forward.

Any feedback is welcome.

#34 - 2019-10-09 13:41 - José Esteves

- File 0001b-Adds-Add-notes-link-to-issue-page-to-add-only-notes.patch added

+1 for this feature!

I'm testing Marius Patch and Is working great so far, even in reverse chronological order of notes.
Mobile also looks good

Just have to resolve un minor conflict to match master branch.

| attach the updated patch!

#35 - 2019-10-09 13:55 - José Esteves
- File 0001b-Adds-Add-notes-link-to-issue-page-to-add-only-notes.patch added

Sorry, here is the patch to latest master!

#36 - 2020-01-30 11:55 - Robert Réttger

+1 for this
#37 - 2021-03-05 08:57 - Leo L.

Hey everyone.

| tried to apply the latest patch, but it fails for some reason | couldn't figured out :

|diff --git a/app/views/issues/_action_menu.html.erb b/app/views/issues/_action_menu.html.erb
|index b535fae..de255bc 100644

|-—— a/app/views/issues/_action_menu.html.erb

|+++ b/app/views/issues/_action_menu.html.erb

File to patch:

Can someone point me at the right direction ?
Thanks :)

Léo.

#38 - 2021-03-05 18:44 - Ismael Barros?
Which command did you use to apply the patch? patch -p0? patch -p17? git apply?

#39 - 2021-04-01 18:16 - Leo L.
Ismael Barros2 wrote:

Which command did you use to apply the patch? patch -p0? patch -p1? git apply?

Hey Ismael,

Sorry | didn't check on updates about that.
| used "patch -p0 < 0001b-Adds-Add-notes-link-to-issue-page-to-add-only-notes.patch" inside redmine root's folder.

(saw on https://www.redmine.org/projects/redmine/wiki h)
For the record, the detailed error message :
gorby@server:/usr/www/redmine # patch -p0 < 000lb-Adds-Add-notes-link-to-issue-page-to-add-only-notes.patch

Hmm... Looks like a unified diff to me...
The text leading up to this was:

|[From 472b31017a84d8c91330dccfb47d241c8aed4a2bb Mon Sep 17 00:00:00 2001
|[From: Marius <marius.****@zitec.com>

|Date: Tue, 26 Feb 2019 07:33:10 +0000

|Subject: Adds "Add notes" link to issue page to add only notes

I

| Signed-off-by: Jose <jose@***>

| app/views/issues/_action_menu.html.erb | 3 +++

| app/views/issues/_action_menu_edit.html.erb | 2 +-

| app/views/issues/_edit.html.erb | 8 +4++————

| config/locales/en.yml |1+

| public/javascripts/application. js | 14 ++++++++++++++
| public/stylesheets/application.css | 2 +-

|

6 files changed, 24 insertions(+), 6 deletions|(-)

|diff --git a/app/views/issues/_action_menu.html.erb b/app/views/issues/_action_menu.html.erb
|index bd7bcc05f..aabd5c021 100644

|-—— a/app/views/issues/_action_menu.html.erb

|+++ b/app/views/issues/_action_menu.html.erb

#40 - 2021-04-01 21:52 - Ismael Barros?

Directories a/ and b/ won't actually exist on your filesystem, so | think you need to use patch -p1 instead of patch -p0

#41 - 2021-04-02 08:31 - Leo L.

Ismael Barros? wrote:
Directories a/ and b/ won't actually exist on your filesystem, so | think you need to use patch -p1 instead of patch -p0

Ismael,

Thanks for the heads up, | didn't know anything about the "patch" command :)

Your suggestion was correct, and with "p1" instead of "p0", everything run smoothly.

Greetings from Paris, France !

Léo.

#42 - 2023-01-11 13:48 - Dmitry Makurin
- File 3143.patch added

An updated patch 3143.patch for r22024.

#43 - 2025-01-01 04:42 - Outvi V

It seems that 6.x has some changes that make the patch unable to apply. If someone is interested, I've crated a client-side UserScript implementation

of this feature targeting Redmine 6.0.2 (and redmine.org) that can be used without server-side code modification:

<https://greasyfork.org/en/scripts/522450-redmine-add-notes-directly-at-the-bottom>
